<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'saleServiceCancelReasonResponse' => '\\StructType\\SaleServiceCancelReasonResponse',
            'reasons' => '\\StructType\\Reasons',
            'baseResponse' => '\\StructType\\BaseResponse',
            'saleReasonType' => '\\StructType\\SaleReasonType',
            'errorType' => '\\StructType\\ErrorType',
            'messageServiceResponse' => '\\StructType\\MessageServiceResponse',
            'saleServicePagingResponse' => '\\StructType\\SaleServicePagingResponse',
            'saleServiceResponse' => '\\StructType\\SaleServiceResponse',
            'sales' => '\\StructType\\Sales',
            'sellerPromotionInfos' => '\\StructType\\SellerPromotionInfos',
            'saleType' => '\\StructType\\SaleType',
            'waitingProcesses' => '\\StructType\\WaitingProcesses',
            'variantSpecs' => '\\StructType\\VariantSpecs',
            'orderBuyerInfoType' => '\\StructType\\OrderBuyerInfoType',
            'neighborhoodType' => '\\StructType\\NeighborhoodType',
            'saleInvoiceType' => '\\StructType\\SaleInvoiceType',
            'itemVariantSpecType' => '\\StructType\\ItemVariantSpecType',
            'shippingInfoType' => '\\StructType\\ShippingInfoType',
            'combinedSaleCodes' => '\\StructType\\CombinedSaleCodes',
            'sellerPromotionInfoType' => '\\StructType\\SellerPromotionInfoType',
            'saleSellerPromotions' => '\\StructType\\SaleSellerPromotions',
            'saleSellerPromotionType' => '\\StructType\\SaleSellerPromotionType',
            'sellerPromotion' => '\\StructType\\SellerPromotion',
            'giftInfoType' => '\\StructType\\GiftInfoType',
            'sellerPromotionItem' => '\\StructType\\SellerPromotionItem',
            'mainProducts' => '\\StructType\\MainProducts',
            'gifts' => '\\StructType\\Gifts',
            'mainProductInfoDto' => '\\StructType\\MainProductInfoDto',
            'images' => '\\StructType\\Images',
            'imageDto' => '\\StructType\\ImageDto',
            'imageUrls' => '\\StructType\\ImageUrls',
            'imageUrlDto' => '\\StructType\\ImageUrlDto',
            'giftProductInfoDto' => '\\StructType\\GiftProductInfoDto',
            'variantDto' => '\\StructType\\VariantDto',
            'specs' => '\\StructType\\Specs',
            'variantSpecDto' => '\\StructType\\VariantSpecDto',
            'productCatalogDto' => '\\StructType\\ProductCatalogDto',
            'saleServiceBuyerResponse' => '\\StructType\\SaleServiceBuyerResponse',
            'itemBuyers' => '\\StructType\\ItemBuyers',
            'saleBuyerType' => '\\StructType\\SaleBuyerType',
            'commonSaleResponse' => '\\StructType\\CommonSaleResponse',
            'saleProcessReportResponse' => '\\StructType\\SaleProcessReportResponse',
            'saleProcessType' => '\\StructType\\SaleProcessType',
            'saleProcessReportV2Response' => '\\StructType\\SaleProcessReportV2Response',
            'saleProcessTypeV2' => '\\StructType\\SaleProcessTypeV2',
            'srsProcessFvfCommissionType' => '\\StructType\\SrsProcessFvfCommissionType',
            'accountTransactionListResponse' => '\\StructType\\AccountTransactionListResponse',
            'accountTransactionType' => '\\StructType\\AccountTransactionType',
            'accountTransactionListV2Response' => '\\StructType\\AccountTransactionListV2Response',
            'accountTransactionV2Type' => '\\StructType\\AccountTransactionV2Type',
            'accountTransactionListV3Response' => '\\StructType\\AccountTransactionListV3Response',
            'accountTransactionV3Type' => '\\StructType\\AccountTransactionV3Type',
            'commissions' => '\\StructType\\Commissions',
            'accountTransactionFvfCommissionType' => '\\StructType\\AccountTransactionFvfCommissionType',
        );
    }
}
