<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for imageUrls StructType
 * @subpackage Structs
 */
class ImageUrls extends AbstractStructBase
{
    /**
     * The imageUrl
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\ImageUrlDto[]
     */
    public $imageUrl;
    /**
     * Constructor method for imageUrls
     * @uses ImageUrls::setImageUrl()
     * @param \StructType\ImageUrlDto[] $imageUrl
     */
    public function __construct(array $imageUrl = array())
    {
        $this
            ->setImageUrl($imageUrl);
    }
    /**
     * Get imageUrl value
     * @return \StructType\ImageUrlDto[]|null
     */
    public function getImageUrl()
    {
        return $this->imageUrl;
    }
    /**
     * This method is responsible for validating the values passed to the setImageUrl method
     * This method is willingly generated in order to preserve the one-line inline validation within the setImageUrl method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateImageUrlForArrayConstraintsFromSetImageUrl(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $imageUrlsImageUrlItem) {
            // validation for constraint: itemType
            if (!$imageUrlsImageUrlItem instanceof \StructType\ImageUrlDto) {
                $invalidValues[] = is_object($imageUrlsImageUrlItem) ? get_class($imageUrlsImageUrlItem) : sprintf('%s(%s)', gettype($imageUrlsImageUrlItem), var_export($imageUrlsImageUrlItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The imageUrl property can only contain items of type \StructType\ImageUrlDto, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set imageUrl value
     * @throws \InvalidArgumentException
     * @param \StructType\ImageUrlDto[] $imageUrl
     * @return \StructType\ImageUrls
     */
    public function setImageUrl(array $imageUrl = array())
    {
        // validation for constraint: array
        if ('' !== ($imageUrlArrayErrorMessage = self::validateImageUrlForArrayConstraintsFromSetImageUrl($imageUrl))) {
            throw new \InvalidArgumentException($imageUrlArrayErrorMessage, __LINE__);
        }
        $this->imageUrl = $imageUrl;
        return $this;
    }
    /**
     * Add item to imageUrl value
     * @throws \InvalidArgumentException
     * @param \StructType\ImageUrlDto $item
     * @return \StructType\ImageUrls
     */
    public function addToImageUrl(\StructType\ImageUrlDto $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ImageUrlDto) {
            throw new \InvalidArgumentException(sprintf('The imageUrl property can only contain items of type \StructType\ImageUrlDto, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->imageUrl[] = $item;
        return $this;
    }
}
