<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for neighborhoodType StructType
 * @subpackage Structs
 */
class NeighborhoodType extends AbstractStructBase
{
    /**
     * The neighborhoodId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $neighborhoodId;
    /**
     * The neighborhoodName
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $neighborhoodName;
    /**
     * The districtId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $districtId;
    /**
     * The active
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $active;
    /**
     * Constructor method for neighborhoodType
     * @uses NeighborhoodType::setNeighborhoodId()
     * @uses NeighborhoodType::setNeighborhoodName()
     * @uses NeighborhoodType::setDistrictId()
     * @uses NeighborhoodType::setActive()
     * @param int $neighborhoodId
     * @param string $neighborhoodName
     * @param int $districtId
     * @param bool $active
     */
    public function __construct($neighborhoodId = null, $neighborhoodName = null, $districtId = null, $active = null)
    {
        $this
            ->setNeighborhoodId($neighborhoodId)
            ->setNeighborhoodName($neighborhoodName)
            ->setDistrictId($districtId)
            ->setActive($active);
    }
    /**
     * Get neighborhoodId value
     * @return int|null
     */
    public function getNeighborhoodId()
    {
        return $this->neighborhoodId;
    }
    /**
     * Set neighborhoodId value
     * @param int $neighborhoodId
     * @return \StructType\NeighborhoodType
     */
    public function setNeighborhoodId($neighborhoodId = null)
    {
        // validation for constraint: int
        if (!is_null($neighborhoodId) && !(is_int($neighborhoodId) || ctype_digit($neighborhoodId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($neighborhoodId, true), gettype($neighborhoodId)), __LINE__);
        }
        $this->neighborhoodId = $neighborhoodId;
        return $this;
    }
    /**
     * Get neighborhoodName value
     * @return string|null
     */
    public function getNeighborhoodName()
    {
        return $this->neighborhoodName;
    }
    /**
     * Set neighborhoodName value
     * @param string $neighborhoodName
     * @return \StructType\NeighborhoodType
     */
    public function setNeighborhoodName($neighborhoodName = null)
    {
        // validation for constraint: string
        if (!is_null($neighborhoodName) && !is_string($neighborhoodName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($neighborhoodName, true), gettype($neighborhoodName)), __LINE__);
        }
        $this->neighborhoodName = $neighborhoodName;
        return $this;
    }
    /**
     * Get districtId value
     * @return int|null
     */
    public function getDistrictId()
    {
        return $this->districtId;
    }
    /**
     * Set districtId value
     * @param int $districtId
     * @return \StructType\NeighborhoodType
     */
    public function setDistrictId($districtId = null)
    {
        // validation for constraint: int
        if (!is_null($districtId) && !(is_int($districtId) || ctype_digit($districtId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($districtId, true), gettype($districtId)), __LINE__);
        }
        $this->districtId = $districtId;
        return $this;
    }
    /**
     * Get active value
     * @return bool|null
     */
    public function getActive()
    {
        return $this->active;
    }
    /**
     * Set active value
     * @param bool $active
     * @return \StructType\NeighborhoodType
     */
    public function setActive($active = null)
    {
        // validation for constraint: boolean
        if (!is_null($active) && !is_bool($active)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($active, true), gettype($active)), __LINE__);
        }
        $this->active = $active;
        return $this;
    }
}
