<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for saleBuyerType StructType
 * @subpackage Structs
 */
class SaleBuyerType extends AbstractStructBase
{
    /**
     * The nick
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $nick;
    /**
     * The saleCount
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $saleCount;
    /**
     * Constructor method for saleBuyerType
     * @uses SaleBuyerType::setNick()
     * @uses SaleBuyerType::setSaleCount()
     * @param string $nick
     * @param int $saleCount
     */
    public function __construct($nick = null, $saleCount = null)
    {
        $this
            ->setNick($nick)
            ->setSaleCount($saleCount);
    }
    /**
     * Get nick value
     * @return string|null
     */
    public function getNick()
    {
        return $this->nick;
    }
    /**
     * Set nick value
     * @param string $nick
     * @return \StructType\SaleBuyerType
     */
    public function setNick($nick = null)
    {
        // validation for constraint: string
        if (!is_null($nick) && !is_string($nick)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($nick, true), gettype($nick)), __LINE__);
        }
        $this->nick = $nick;
        return $this;
    }
    /**
     * Get saleCount value
     * @return int|null
     */
    public function getSaleCount()
    {
        return $this->saleCount;
    }
    /**
     * Set saleCount value
     * @param int $saleCount
     * @return \StructType\SaleBuyerType
     */
    public function setSaleCount($saleCount = null)
    {
        // validation for constraint: int
        if (!is_null($saleCount) && !(is_int($saleCount) || ctype_digit($saleCount))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($saleCount, true), gettype($saleCount)), __LINE__);
        }
        $this->saleCount = $saleCount;
        return $this;
    }
}
