<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for saleSellerPromotions StructType
 * @subpackage Structs
 */
class SaleSellerPromotions extends AbstractStructBase
{
    /**
     * The saleSellerPromotion
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\SaleSellerPromotionType[]
     */
    public $saleSellerPromotion;
    /**
     * Constructor method for saleSellerPromotions
     * @uses SaleSellerPromotions::setSaleSellerPromotion()
     * @param \StructType\SaleSellerPromotionType[] $saleSellerPromotion
     */
    public function __construct(array $saleSellerPromotion = array())
    {
        $this
            ->setSaleSellerPromotion($saleSellerPromotion);
    }
    /**
     * Get saleSellerPromotion value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\SaleSellerPromotionType[]|null
     */
    public function getSaleSellerPromotion()
    {
        return isset($this->saleSellerPromotion) ? $this->saleSellerPromotion : null;
    }
    /**
     * This method is responsible for validating the values passed to the setSaleSellerPromotion method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSaleSellerPromotion method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSaleSellerPromotionForArrayConstraintsFromSetSaleSellerPromotion(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $saleSellerPromotionsSaleSellerPromotionItem) {
            // validation for constraint: itemType
            if (!$saleSellerPromotionsSaleSellerPromotionItem instanceof \StructType\SaleSellerPromotionType) {
                $invalidValues[] = is_object($saleSellerPromotionsSaleSellerPromotionItem) ? get_class($saleSellerPromotionsSaleSellerPromotionItem) : sprintf('%s(%s)', gettype($saleSellerPromotionsSaleSellerPromotionItem), var_export($saleSellerPromotionsSaleSellerPromotionItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The saleSellerPromotion property can only contain items of type \StructType\SaleSellerPromotionType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set saleSellerPromotion value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\SaleSellerPromotionType[] $saleSellerPromotion
     * @return \StructType\SaleSellerPromotions
     */
    public function setSaleSellerPromotion(array $saleSellerPromotion = array())
    {
        // validation for constraint: array
        if ('' !== ($saleSellerPromotionArrayErrorMessage = self::validateSaleSellerPromotionForArrayConstraintsFromSetSaleSellerPromotion($saleSellerPromotion))) {
            throw new \InvalidArgumentException($saleSellerPromotionArrayErrorMessage, __LINE__);
        }
        if (is_null($saleSellerPromotion) || (is_array($saleSellerPromotion) && empty($saleSellerPromotion))) {
            unset($this->saleSellerPromotion);
        } else {
            $this->saleSellerPromotion = $saleSellerPromotion;
        }
        return $this;
    }
    /**
     * Add item to saleSellerPromotion value
     * @throws \InvalidArgumentException
     * @param \StructType\SaleSellerPromotionType $item
     * @return \StructType\SaleSellerPromotions
     */
    public function addToSaleSellerPromotion(\StructType\SaleSellerPromotionType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SaleSellerPromotionType) {
            throw new \InvalidArgumentException(sprintf('The saleSellerPromotion property can only contain items of type \StructType\SaleSellerPromotionType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->saleSellerPromotion[] = $item;
        return $this;
    }
}
