<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for saleServiceCancelReasonResponse StructType
 * @subpackage Structs
 */
class SaleServiceCancelReasonResponse extends BaseResponse
{
    /**
     * The count
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $count;
    /**
     * The reasons
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\Reasons
     */
    public $reasons;
    /**
     * Constructor method for saleServiceCancelReasonResponse
     * @uses SaleServiceCancelReasonResponse::setCount()
     * @uses SaleServiceCancelReasonResponse::setReasons()
     * @param int $count
     * @param \StructType\Reasons $reasons
     */
    public function __construct($count = null, \StructType\Reasons $reasons = null)
    {
        $this
            ->setCount($count)
            ->setReasons($reasons);
    }
    /**
     * Get count value
     * @return int|null
     */
    public function getCount()
    {
        return $this->count;
    }
    /**
     * Set count value
     * @param int $count
     * @return \StructType\SaleServiceCancelReasonResponse
     */
    public function setCount($count = null)
    {
        // validation for constraint: int
        if (!is_null($count) && !(is_int($count) || ctype_digit($count))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($count, true), gettype($count)), __LINE__);
        }
        $this->count = $count;
        return $this;
    }
    /**
     * Get reasons value
     * @return \StructType\Reasons|null
     */
    public function getReasons()
    {
        return $this->reasons;
    }
    /**
     * Set reasons value
     * @param \StructType\Reasons $reasons
     * @return \StructType\SaleServiceCancelReasonResponse
     */
    public function setReasons(\StructType\Reasons $reasons = null)
    {
        $this->reasons = $reasons;
        return $this;
    }
}
