<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for sellerPromotionInfos StructType
 * @subpackage Structs
 */
class SellerPromotionInfos extends AbstractStructBase
{
    /**
     * The sellerPromotionInfo
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\SellerPromotionInfoType[]
     */
    public $sellerPromotionInfo;
    /**
     * Constructor method for sellerPromotionInfos
     * @uses SellerPromotionInfos::setSellerPromotionInfo()
     * @param \StructType\SellerPromotionInfoType[] $sellerPromotionInfo
     */
    public function __construct(array $sellerPromotionInfo = array())
    {
        $this
            ->setSellerPromotionInfo($sellerPromotionInfo);
    }
    /**
     * Get sellerPromotionInfo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\SellerPromotionInfoType[]|null
     */
    public function getSellerPromotionInfo()
    {
        return isset($this->sellerPromotionInfo) ? $this->sellerPromotionInfo : null;
    }
    /**
     * This method is responsible for validating the values passed to the setSellerPromotionInfo method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSellerPromotionInfo method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSellerPromotionInfoForArrayConstraintsFromSetSellerPromotionInfo(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $sellerPromotionInfosSellerPromotionInfoItem) {
            // validation for constraint: itemType
            if (!$sellerPromotionInfosSellerPromotionInfoItem instanceof \StructType\SellerPromotionInfoType) {
                $invalidValues[] = is_object($sellerPromotionInfosSellerPromotionInfoItem) ? get_class($sellerPromotionInfosSellerPromotionInfoItem) : sprintf('%s(%s)', gettype($sellerPromotionInfosSellerPromotionInfoItem), var_export($sellerPromotionInfosSellerPromotionInfoItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The sellerPromotionInfo property can only contain items of type \StructType\SellerPromotionInfoType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set sellerPromotionInfo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\SellerPromotionInfoType[] $sellerPromotionInfo
     * @return \StructType\SellerPromotionInfos
     */
    public function setSellerPromotionInfo(array $sellerPromotionInfo = array())
    {
        // validation for constraint: array
        if ('' !== ($sellerPromotionInfoArrayErrorMessage = self::validateSellerPromotionInfoForArrayConstraintsFromSetSellerPromotionInfo($sellerPromotionInfo))) {
            throw new \InvalidArgumentException($sellerPromotionInfoArrayErrorMessage, __LINE__);
        }
        if (is_null($sellerPromotionInfo) || (is_array($sellerPromotionInfo) && empty($sellerPromotionInfo))) {
            unset($this->sellerPromotionInfo);
        } else {
            $this->sellerPromotionInfo = $sellerPromotionInfo;
        }
        return $this;
    }
    /**
     * Add item to sellerPromotionInfo value
     * @throws \InvalidArgumentException
     * @param \StructType\SellerPromotionInfoType $item
     * @return \StructType\SellerPromotionInfos
     */
    public function addToSellerPromotionInfo(\StructType\SellerPromotionInfoType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SellerPromotionInfoType) {
            throw new \InvalidArgumentException(sprintf('The sellerPromotionInfo property can only contain items of type \StructType\SellerPromotionInfoType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->sellerPromotionInfo[] = $item;
        return $this;
    }
}
