<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for waitingProcesses StructType
 * @subpackage Structs
 */
class WaitingProcesses extends AbstractStructBase
{
    /**
     * The waitingProcess
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var int[]
     */
    public $waitingProcess;
    /**
     * Constructor method for waitingProcesses
     * @uses WaitingProcesses::setWaitingProcess()
     * @param int[] $waitingProcess
     */
    public function __construct(array $waitingProcess = array())
    {
        $this
            ->setWaitingProcess($waitingProcess);
    }
    /**
     * Get waitingProcess value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int[]|null
     */
    public function getWaitingProcess()
    {
        return isset($this->waitingProcess) ? $this->waitingProcess : null;
    }
    /**
     * This method is responsible for validating the values passed to the setWaitingProcess method
     * This method is willingly generated in order to preserve the one-line inline validation within the setWaitingProcess method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateWaitingProcessForArrayConstraintsFromSetWaitingProcess(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $waitingProcessesWaitingProcessItem) {
            // validation for constraint: itemType
            if (!(is_int($waitingProcessesWaitingProcessItem) || ctype_digit($waitingProcessesWaitingProcessItem))) {
                $invalidValues[] = is_object($waitingProcessesWaitingProcessItem) ? get_class($waitingProcessesWaitingProcessItem) : sprintf('%s(%s)', gettype($waitingProcessesWaitingProcessItem), var_export($waitingProcessesWaitingProcessItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The waitingProcess property can only contain items of type int, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set waitingProcess value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param int[] $waitingProcess
     * @return \StructType\WaitingProcesses
     */
    public function setWaitingProcess(array $waitingProcess = array())
    {
        // validation for constraint: array
        if ('' !== ($waitingProcessArrayErrorMessage = self::validateWaitingProcessForArrayConstraintsFromSetWaitingProcess($waitingProcess))) {
            throw new \InvalidArgumentException($waitingProcessArrayErrorMessage, __LINE__);
        }
        if (is_null($waitingProcess) || (is_array($waitingProcess) && empty($waitingProcess))) {
            unset($this->waitingProcess);
        } else {
            $this->waitingProcess = $waitingProcess;
        }
        return $this;
    }
    /**
     * Add item to waitingProcess value
     * @throws \InvalidArgumentException
     * @param int $item
     * @return \StructType\WaitingProcesses
     */
    public function addToWaitingProcess($item)
    {
        // validation for constraint: itemType
        if (!(is_int($item) || ctype_digit($item))) {
            throw new \InvalidArgumentException(sprintf('The waitingProcess property can only contain items of type int, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->waitingProcess[] = $item;
        return $this;
    }
}
